unit MyBusyCursors;

interface

	procedure InitBusyCursors (spin_cursor: boolean; first_cursor, last_cursor: integer);
	procedure FinishBusyCursors;
	procedure SpinBusyCursor;
	procedure FinishBusyCursor;

implementation

	var
		display_cursor: boolean;
		first_idle_cursor, last_idle_cursor, idle_cursor: integer;

	procedure InitBusyCursors (spin_cursor: boolean; first_cursor, last_cursor: integer);
	begin
		display_cursor := spin_cursor;
		first_idle_cursor := first_cursor;
		idle_cursor := first_cursor;
		last_idle_cursor := last_cursor;
	end;

	procedure FinishBusyCursors;
	begin
	end;

	procedure SpinBusyCursor;
	begin
		if (first_idle_cursor <= idle_cursor) and (idle_cursor < last_idle_cursor) then
			idle_cursor := idle_cursor + 1
		else
			idle_cursor := first_idle_cursor;
		SetCursor(GetCursor(idle_cursor)^^);
	end;

	procedure FinishBusyCursor;
	begin
		InitCursor;
	end;

end.