unit MyLogs;
	/ / /
interface

	procedure Log (s: str255);

implementation

	uses
		PrefCodes, MyNewPreferences, MyFetchSuffix, MyFileSystemUtils, MyTypes, MyStrH;

	procedure Log (s: str255);
		var
			err: OSErr;
			fs: FSSpec;
			isfolder, wasaliase: boolean;
			logrn: integer;
			time: longInt;
			d, t: str255;
	begin
		if prefs.GetTagBoolean(PC_Log) then begin
			err := FSMakeFSSpec(the_prefs_folder_vrn, the_prefs_folder_dirID, GetIndStr(128, 36), fs);
			if err = noErr then
				err := ResolveAliasFile(fs, true, isfolder, wasaliase);
			err := FSpCreate(fs, GetTextCreator, 'TEXT', 0);
			err := FSpOpenDF(fs, fsWrPerm, logrn);
			if err = noErr then begin
				err := SetFPos(logrn, fsFromLEOF, 0);
				if err = noErr then begin
					GetDateTime(time);
					IUDateString(time, shortDate, d);
					IUTimeString(time, false, t);
					s := concat(d, chr(9), t, chr(9), s, cr);
					err := MyFSWrite(logrn, length(s), @s[1]);
				end;
				err := FSClose(logrn);
			end;
		end;
	end;

end.