unit MyMathUtils;

interface

	function Min (a, b: longInt): longInt;
	inline
		$201F, $2E9F, $B097, $6C02, $2E80;

	function Max (a, b: longInt): longInt;
	inline
		$201F, $2E9F, $B097, $6F02, $2E80;

	function Pin (a, b, c: longInt): longInt;
	inline
		$201F, $221F, $B280, $6F02, $2200, $201F, $B280, $6C02, $2200, $2E81;

	function Choose (cond: boolean; a, b: longInt): longInt;
	inline
		$201F, $221F, $4A1F, $6602, $2200, $2E81;

implementation

end.

function Max (a, b: longInt): longInt;
begin
	if a > b then
		Max := a
	else
		Max := b;
end;

function Min (a, b: longInt): longInt;
begin
	if a < b then
		Min := a
	else
		Min := b;
end;

function Pin (a, b, c: longInt): longInt;
begin
	if b < a then
		Pin := a
	else if b > c then
		Pin := c
	else
		Pin := b;
end;

function Choose (cond: boolean; a, b: longInt): longInt;
begin
	if cond then begin
		Choose := a;
	end
	else begin
		Choose := b;
	end;
end;