unit MySizeResource;

interface

	type
		sizeRsrc = packed record
				obsolete1: boolean;
				accept_suspend_events: boolean;
				obsolete2: boolean;
				can_background: boolean;
				does_activate_on_fg_switch: boolean;
				only_background: boolean;
				get_front_clicks: boolean;
				accept_app_died_events: boolean;
				bit_32_compatibile: boolean;
				high_level_event_aware: boolean;
				local_remote_hl_events: boolean;
				stationary_aware: boolean;
				use_textedit_services: boolean;
				reserved1: boolean;
				reserved2: boolean;
				reserved3: boolean;
				size: longInt;
				min_size: longInt;
			end;

	procedure GetSizeResource (var size: sizeRsrc);

implementation

{$IFC undefined THINK_Pascal}
	uses
		Types, Resources, Memory;
{$ENDC}

	procedure GetSizeResource (var size: sizeRsrc);
		var
			h: handle;
			p: ^integer;
	begin
		h := Get1Resource('SIZE', 0);
		if (h = nil) | (GetHandleSize(h) <> SizeOf(sizeRsrc)) then
			h := Get1Resource('SIZE', -1);
		if (h = nil) | (GetHandleSize(h) <> SizeOf(sizeRsrc)) then begin
			p := @size;
			p^ := 0;
			size.size := longInt(384) * 1024;
			size.min_size := longInt(384) * 1024;
		end
		else begin
			BlockMove(h^, @size, SizeOf(sizeRsrc));
		end;
	end;

end.