unit MyTrace;

interface

	const
		max_trace = 1000;
	type
		TraceRecord = record
				pos: longInt;
				data: array[1..max_trace] of integer;
			end;
	var
		tp: ^TraceRecord;

	procedure InitTrace;
	procedure Trace (n: integer);

implementation

	procedure InitTrace;
	begin
		tp := POINTER(NewPtr(SizeOf(TraceRecord)));
		tp^.pos := 1;
		BlockZero(@tp^.data, SizeOf(tp^.data));
	end;

{$PUSH}
{$D-}
	procedure Trace (n: integer);
	begin
		tp^.data[tp^.pos] := n;
		tp^.pos := (tp^.pos mod max_trace) + 1;
	end;
{$POP}

end.
