unit MyAEDump;

interface

	uses
		AppleEvents;

	procedure DumpAppleEvent (event: AppleEvent);

implementation

	uses
		MyDumping;

	procedure DumpAppleEvent (event: AppleEvent);
		var
			err, junk: OSErr;
			index: integer;
			desc: AEDesc;
			key: AEKeyword;
	begin
		DumpLine('AppleEvent is:');
		index := 1;
		repeat
			err := AEGetNthDesc(event, index, typeWildCard, key, desc);
			if err = noErr then begin
				DumpLine(StringOf(key, ': ', desc.descriptorType));
				if desc.dataHandle <> nil then begin
					HLock(desc.dataHandle);
					DumpData(desc.dataHandle^, GetHandleSize(desc.dataHandle));
				end;
				junk := AEDisposeDesc(desc);
				index := index + 1;
			end;
		until err <> noErr;
		DumpLine('');
	end;

end.