unit MySocks;

interface

	const
		socks_default_port = 1080;
		socks_version = 4;

	const { Response commands/codes }
		socks_connect = 1;
		socks_bind = 2;
		socks_result = 90;
		socks_fail = 91;

	type
		SocksRecordSmall = packed record
				version: byte;
				cmd: byte;
				port: integer;
				ip: longInt;
			end;
		SocksRecord = packed record
				version: byte;
				cmd: byte;
				port: integer;
				ip: longInt;
				name: str63; {cstring!}
			end;

implementation

end.
const
	socks_version = 3;
type
	SocksRecordSmall = packed record
			version: byte;
			cmd: byte;
			port: longInt;
			ip: longInt;
		end;
	SocksRecord = packed record
			version: byte;
			cmd: byte;
			port: longInt;
			ip: longInt;
			name: str63; {cstring!}
		end;