unit MyWakeUp;

interface

	procedure InitWakeUp;
	procedure FinishWakeUp;
	procedure WakeUp;

implementation

	uses
		Processes;

	var
		our_psn: ProcessSerialNumber;

{$PUSH}
{$D-}

	procedure WakeUp;
		var
			junk: OSErr;
	begin
		if (our_psn.highLongOfPSN <> 0) or (our_psn.lowLongOfPSN <> 0) then begin
			junk := WakeUpProcess(our_psn);
		end;
	end;

{$POP}

	procedure InitWakeUp;
		var
			gv: longInt;
			junk: OSErr;
	begin
		our_psn.highLongOfPSN := 0;
		our_psn.lowLongOfPSN := 0;
		if (Gestalt(gestaltOSAttr, gv) = noErr) & (BTST(gv, gestaltLaunchControl)) then begin
			junk := GetCurrentProcess(our_psn);
		end;
	end;

	procedure FinishWakeUp;
	begin
	end;

end.